SystemOrganization addCategory: #'tODE-Views'!

TORenderer subclass: #TOView
	instanceVariableNames: 'ctlKeyPressed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

TOView subclass: #TOSharedClassState
	instanceVariableNames: 'selectedSuperclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOSharedClassState methodsFor: 'rendering' stamp: 'dkh 6/2/2011 03:45'!
renderSuperclassHeading: aClass on: html main: main
	self
		renderSuperclassHeading: aClass
		renderName: [:cl | html strong: cl name ]
		whenClicked: [self selectedSuperclassChanged]
		on: html
		main: main.

! !

!TOSharedClassState methodsFor: 'rendering' stamp: 'dkh 5/26/2011 20:55'!
renderSuperclassHeading: aClass renderName: renderNameBlock on: html main: main
	self
		renderSuperclassHeading: aClass
		renderName: renderNameBlock
		whenClicked: [ self selectedSuperclassChanged ]
		on: html
		main: main! !

!TOSharedClassState methodsFor: 'rendering' stamp: 'dkh 6/3/2011 15:55'!
renderSuperclassHeading: aClass renderName: renderNameBlock whenClicked: aBlock on: html main: main
	html text: 'Superclasses: '.
	aClass allSuperclasses reversed
		do: [ :supClass | 
			supClass == self selectedSuperclass
				ifTrue: [ renderNameBlock value: supClass ]
				ifFalse: [ 
					self
						renderLink: [ :s | 
							self selectedSuperclass: supClass.
							aBlock value.
							main updateCenterSideHistory: s ]
						with: [ renderNameBlock value: supClass ]
						on: html ].
			html text: '->' ].
	self selectedSuperclass == nil
		ifTrue: [ renderNameBlock value: aClass ]
		ifFalse: [ 
			self
				renderLink: [ :s | 
					self selectedSuperclass: nil.
					aBlock value.
					main updateCenterSideHistory: s ]
				with: [ renderNameBlock value: aClass ]
				on: html ].
	html text: ' [ '.
	aClass isMeta
		ifTrue: [ 
			self
				renderLink: [ :s | 
					self currentSession push: aClass theNonMetaClass selecting: #classBrowser.
					main updateCenterSideHistory: s ]
				with: [html text: 'instance']
				on: html ]
		ifFalse: [ 
			self
				renderLink: [ :s | 
					self currentSession push: aClass class selecting: #classBrowser.
					main updateCenterSideHistory: s ]
				with: [html text: 'class']
				on: html ].
	html text: ' ]'.! !

!TOSharedClassState methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:11'!
selectedSuperclass
	^ selectedSuperclass! !

!TOSharedClassState methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:11'!
selectedSuperclass: anObject
	^ selectedSuperclass := anObject! !

!TOSharedClassState methodsFor: 'events' stamp: 'dkh 5/29/2011 10:15'!
selectedSuperclassChanged
	#(#methodSourceBrowser #methodCategoryBrowser #classBrowser)
		do: [ :id | frame properties at: id ifPresent: [ :view | view selectedSuperclassChanged ] ]! !

!TOView methodsFor: 'rendering' stamp: 'dkh 5/22/2011 17:25'!
renderClassHeading: aClass on: html main: main

	self renderSuperclassHeading: aClass on: html main: main.
! !

!TOView methodsFor: 'rendering' stamp: 'dkh 5/26/2011 13:53'!
renderSuperclassHeading: aClass on: html main: main
	self sharedClassState
		renderSuperclassHeading: aClass
		on: html
		main: main! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:25'!
selectedSuperclass
	^self sharedClassState selectedSuperclass! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:25'!
selectedSuperclass: anObject
	self sharedClassState selectedSuperclass: anObject! !

!TOView methodsFor: 'events' stamp: 'dkh 5/26/2011 13:47'!
selectedSuperclassChanged! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/27/2011 09:09'!
sharedClassState
	^ self frame properties
		at: #sharedClassState
		ifAbsent: [ 
			self frame properties
				at: #sharedClassState
				put:
					((TOSharedClassState new)
						object: self object;
						frame: self frame;
						yourself) ]! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/27/2011 14:43'!
textAreaColumns: text

	| lineWidth tab |
	lineWidth := 0.
	tab := Character tab.
	text linesDo: [:line | | tabs |
		tabs := 0.
		line do: [:char | char = tab ifTrue: [ tabs := tabs + 5 ]].
		lineWidth := lineWidth max: (line size + tabs)].
	^lineWidth! !

!TOView methodsFor: 'accessing' stamp: 'dkh 6/17/2011 15:57'!
textAreaRows: text

	| lineCount |
	lineCount := 0.
	text linesDo:[:line | lineCount := lineCount + 1 ].
	^lineCount+1! !

!TOView methodsFor: 'accessing' stamp: 'dkh 05/27/2011 11:46'!
theClass

	^self selectedSuperclass ifNil: [ self actualClass ]! !

Notification subclass: #TOAbortCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

Notification subclass: #TOErrorCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!
